package domain_test

import (
	"testing"

	"gitea.dwysokinski.me/Kichiyaki/notificationarr/internal/domain"
	"github.com/stretchr/testify/assert"
)

func TestNewRadarrEventType(t *testing.T) {
	t.Parallel()

	t.Run("OK", func(t *testing.T) {
		t.Parallel()

		events := []domain.RadarrEventType{domain.RadarrEventTypeDownload, domain.RadarrEventTypeTest}

		for _, ev := range events {
			res, err := domain.NewRadarrEventType(ev.String())
			assert.Equal(t, ev, res)
			assert.NoError(t, err)
		}
	})

	t.Run("ERR: invalid event type", func(t *testing.T) {
		t.Parallel()

		events := []string{"test1", "test2", "aaaa", "bbb"}

		for _, ev := range events {
			res, err := domain.NewRadarrEventType(ev)
			assert.Zero(t, res)
			assert.ErrorIs(t, err, domain.ErrUnsupportedRadarrEventType)
		}
	})
}
