package domain_test

import (
	"testing"

	"github.com/stretchr/testify/assert"

	"gitea.dwysokinski.me/Kichiyaki/notificationarr/internal/domain"
)

func TestNewSonarrEventType(t *testing.T) {
	t.Parallel()

	t.Run("OK", func(t *testing.T) {
		t.Parallel()

		events := []domain.SonarrEventType{domain.SonarrEventTypeDownload, domain.SonarrEventTypeTest}

		for _, ev := range events {
			res, err := domain.NewSonarrEventType(ev.String())
			assert.Equal(t, ev, res)
			assert.NoError(t, err)
		}
	})

	t.Run("ERR: invalid event type", func(t *testing.T) {
		t.Parallel()

		events := []string{"test1", "test2", "aaaa", "bbb"}

		for _, ev := range events {
			res, err := domain.NewSonarrEventType(ev)
			assert.Zero(t, res)
			assert.ErrorIs(t, err, domain.ErrUnsupportedSonarrEventType)
		}
	})
}
